PACKAGE types IS
	TYPE agp_bus is RANGE 0 to 1;
	TYPE cardbus is RANGE 0 to 1;
	TYPE dio24 is RANGE 0 to 1;
	TYPE host_bus is RANGE 0 to 1;
	TYPE ide_bus is RANGE 0 to 1;
	TYPE isa_bus is RANGE 0 to 1;
	TYPE match is RANGE 0 to 1;
	TYPE mem_bus is RANGE 0 to 1;
	TYPE pci_bus is RANGE 0 to 1;
	TYPE power_board is RANGE 0 to 1;
	TYPE power_board_at is RANGE 0 to 1;
	TYPE power_device is RANGE 0 to 1;
	TYPE ps2 is RANGE 0 to 1;
	TYPE scsi_bus is RANGE 0 to 1;
	TYPE shugart_bus is RANGE 0 to 1;
	TYPE sound is RANGE 0 to 1;
	TYPE usb_bus is RANGE 0 to 1;
	TYPE vga is RANGE 0 to 1;
	TYPE video is RANGE 0 to 1;
	TYPE opt_rgb is RANGE 0 to 1;
	TYPE dio48 is RANGE 0 to 1;
	TYPE eth is RANGE 0 to 1;
	TYPE parallel is RANGE 0 to 1;
	TYPE serial is RANGE 0 to 1;
	TYPE telephone is RANGE 0 to 1;
	TYPE cstring is RANGE 0 to 1;
	TYPE boolean_array is ARRAY(integer RANGE <>) of boolean;
	TYPE integer_array is ARRAY(integer RANGE <>) of integer;
END PACKAGE types;


USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY chassis IS
	PORT (
		mech_power_button : IN boolean;
		n_power_button : OUT std_logic;
		mech_reset_button : IN boolean;
		n_reset_button : OUT std_logic;
		power_led : IN boolean;
		opt_power_led : OUT boolean;
		ide_led : IN boolean;
		opt_ide_led : OUT boolean;
		speaker : IN sound;
		audio_speaker : OUT sound
	);
	ATTRIBUTE foreign OF chassis : ENTITY IS "chassis";
END chassis;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY chassis_at IS
	PORT (
		mech_reset_button : IN boolean;
		n_reset_button : OUT std_logic;
		power_led : IN boolean;
		opt_power_led : OUT boolean;
		speaker : IN sound;
		audio_speaker : IN sound
	);
	ATTRIBUTE foreign OF chassis_at : ENTITY IS "chassis_at";
END chassis_at;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY power_supply IS
	PORT (
		power_230v : IN boolean;
		mech_power_switch : IN boolean;
		power_board : INOUT power_board;
		power_dev0 : OUT power_device;
		power_dev1 : OUT power_device;
		power_dev2 : OUT power_device;
		power_dev3 : OUT power_device;
		power_dev4 : OUT power_device;
		power_dev5 : OUT power_device;
		power_dev6 : OUT power_device;
		power_dev7 : OUT power_device
	);
	ATTRIBUTE foreign OF power_supply : ENTITY IS "power_supply";
END power_supply;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY power_supply_at IS
	PORT (
		power_230v : IN boolean;
		mech_power_switch : IN boolean;
		power_board : INOUT power_board_at;
		power_dev0 : OUT power_device;
		power_dev1 : OUT power_device;
		power_dev2 : OUT power_device;
		power_dev3 : OUT power_device;
		power_dev4 : OUT power_device;
		power_dev5 : OUT power_device;
		power_dev6 : OUT power_device;
		power_dev7 : OUT power_device
	);
	ATTRIBUTE foreign OF power_supply_at : ENTITY IS "power_supply_at";
END power_supply_at;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY mb_ibm_at IS
	GENERIC (
		rtc_start : integer := -1
	);
	PORT (
		power : INOUT power_board_at;
		isa0 : INOUT isa_bus;
		isa1 : INOUT isa_bus;
		isa2 : INOUT isa_bus;
		isa3 : INOUT isa_bus;
		isa4 : INOUT isa_bus;
		isa5 : INOUT isa_bus;
		isa6 : INOUT isa_bus;
		isa7 : INOUT isa_bus;
		keyboard : INOUT ps2;
		speaker : OUT sound;
		power_led : OUT boolean;
		n_reset_button : IN std_logic
	);
	ATTRIBUTE foreign OF mb_ibm_at : ENTITY IS "mb_ibm_at";
END mb_ibm_at;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY mb_ga_686dlx IS
	GENERIC (
		rtc_start : integer := -1
	);
	PORT (
		power : INOUT power_board;
		cpu0 : INOUT host_bus;
		cpu1 : INOUT host_bus;
		mem0 : INOUT mem_bus;
		mem1 : INOUT mem_bus;
		mem2 : INOUT mem_bus;
		mem3 : INOUT mem_bus;
		agp : INOUT agp_bus;
		pci0 : INOUT pci_bus;
		pci1 : INOUT pci_bus;
		pci2 : INOUT pci_bus;
		pci3 : INOUT pci_bus;
		isa0 : INOUT isa_bus;
		isa1 : INOUT isa_bus;
		isa2 : INOUT isa_bus;
		ide0 : INOUT ide_bus;
		ide1 : INOUT ide_bus;
		scsi : INOUT scsi_bus;
		usb0 : INOUT usb_bus;
		usb1 : INOUT usb_bus;
		ser0 : INOUT serial;
		ser1 : INOUT serial;
		par : INOUT parallel;
		keyboard : INOUT ps2;
		mouse : INOUT ps2;
		speaker : OUT sound;
		shugart : INOUT shugart_bus;
		power_led : OUT boolean;
		ide_led : OUT boolean;
		n_power_button : IN std_logic;
		n_reset_button : IN std_logic
	);
	ATTRIBUTE foreign OF mb_ga_686dlx : ENTITY IS "mb_ga_686dlx";
END mb_ga_686dlx;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_generic_host IS
	PORT (
		conn : INOUT host_bus;
		bitflip : boolean
	);
	ATTRIBUTE foreign OF cpu_generic_host : ENTITY IS "cpu_generic_host";
END cpu_generic_host;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_intel_80386 IS
	PORT (
		conn : INOUT host_bus
	);
	ATTRIBUTE foreign OF cpu_intel_80386 : ENTITY IS "cpu_intel_80386";
END cpu_intel_80386;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_intel_80386_interpreter IS
	PORT (
		conn : INOUT host_bus
	);
	ATTRIBUTE foreign OF cpu_intel_80386_interpreter : ENTITY IS "cpu_intel_80386_interpreter";
END cpu_intel_80386_interpreter;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_intel_80686_klamath IS
	PORT (
		conn : INOUT host_bus
	);
	ATTRIBUTE foreign OF cpu_intel_80686_klamath : ENTITY IS "cpu_intel_80686_klamath";
END cpu_intel_80686_klamath;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_intel_80686_coppermine IS
	PORT (
		conn : INOUT host_bus
	);
	ATTRIBUTE foreign OF cpu_intel_80686_coppermine : ENTITY IS "cpu_intel_80686_coppermine";
END cpu_intel_80686_coppermine;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cpu_intel_x86_64 IS
	PORT (
		conn : INOUT host_bus
	);
	ATTRIBUTE foreign OF cpu_intel_x86_64 : ENTITY IS "cpu_intel_x86_64";
END cpu_intel_x86_64;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY memory IS
	GENERIC (
		size : integer := 32
	);
	PORT (
		conn : INOUT mem_bus;
		bitflip : boolean;
		stuck_at_0 : boolean;
		stuck_at_1 : boolean;
		coupling : boolean
	);
	ATTRIBUTE foreign OF memory : ENTITY IS "memory";
END memory;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_ne2000 IS
	GENERIC (
		irq : integer := 0;
		ioaddr : integer := 0;
		mac : string := "00:00:00:00:00:00"
	);
	PORT (
		isa : INOUT isa_bus;
		eth : INOUT eth;
		opt_busy_led : OUT boolean;
		recv_loss : integer;
		send_loss : integer
	);
	ATTRIBUTE foreign OF isa_gen_ne2000 : ENTITY IS "isa_gen_ne2000";
END isa_gen_ne2000;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_idectrl IS
	GENERIC (
		irq : integer := 11;
		ioaddr_8 : integer := 488;
		ioaddr_1 : integer := 1006
	);
	PORT (
		isa : INOUT isa_bus;
		ide : INOUT ide_bus
	);
	ATTRIBUTE foreign OF isa_gen_idectrl : ENTITY IS "isa_gen_idectrl";
END isa_gen_idectrl;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_soundblaster16 IS
	GENERIC (
		irq : integer := 5;
		ioaddr : integer := 544;
		dma8 : integer := 1;
		dma16 : integer := 5
	);
	PORT (
		isa : INOUT isa_bus;
		speaker : INOUT sound
	);
	ATTRIBUTE foreign OF isa_gen_soundblaster16 : ENTITY IS "isa_gen_soundblaster16";
END isa_gen_soundblaster16;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_parallel IS
	GENERIC (
		irq : integer := 5;
		ioaddr : integer := 632
	);
	PORT (
		isa : INOUT isa_bus;
		par : INOUT parallel
	);
	ATTRIBUTE foreign OF isa_gen_parallel : ENTITY IS "isa_gen_parallel";
END isa_gen_parallel;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_serial IS
	GENERIC (
		irq : integer := 4;
		ioaddr : integer := 1000
	);
	PORT (
		isa : INOUT isa_bus;
		ser : INOUT serial
	);
	ATTRIBUTE foreign OF isa_gen_serial : ENTITY IS "isa_gen_serial";
END isa_gen_serial;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY isa_gen_vga IS
	PORT (
		isa : INOUT isa_bus;
		vga : INOUT vga
	);
	ATTRIBUTE foreign OF isa_gen_vga : ENTITY IS "isa_gen_vga";
END isa_gen_vga;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_cirrus_gd5446 IS
	GENERIC (
		name : string := "cirrus_vga_bios.rom"
	);
	PORT (
		pci : INOUT pci_bus;
		vga : INOUT vga
	);
	ATTRIBUTE foreign OF pci_cirrus_gd5446 : ENTITY IS "pci_cirrus_gd5446";
END pci_cirrus_gd5446;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_cirrus_gd5446_2mb IS
	GENERIC (
		name : string := "cirrus_vga_bios.rom"
	);
	PORT (
		pci : INOUT pci_bus;
		vga : INOUT vga
	);
	ATTRIBUTE foreign OF pci_cirrus_gd5446_2mb : ENTITY IS "pci_cirrus_gd5446_2mb";
END pci_cirrus_gd5446_2mb;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_cirrus_gd5446_3mb IS
	GENERIC (
		name : string := "cirrus_vga_bios.rom"
	);
	PORT (
		pci : INOUT pci_bus;
		vga : INOUT vga
	);
	ATTRIBUTE foreign OF pci_cirrus_gd5446_3mb : ENTITY IS "pci_cirrus_gd5446_3mb";
END pci_cirrus_gd5446_3mb;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_intel_eepro100 IS
	GENERIC (
		mac : string := "00:00:00:00:00:00"
	);
	PORT (
		pci : INOUT pci_bus;
		eth : INOUT eth;
		opt_busy_led : OUT boolean;
		recv_loss : integer;
		send_loss : integer
	);
	ATTRIBUTE foreign OF pci_intel_eepro100 : ENTITY IS "pci_intel_eepro100";
END pci_intel_eepro100;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_ti_1520 IS
	PORT (
		pci : INOUT pci_bus;
		card0 : INOUT cardbus;
		card1 : INOUT cardbus
	);
	ATTRIBUTE foreign OF pci_ti_1520 : ENTITY IS "pci_ti_1520";
END pci_ti_1520;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_lsi_20810 IS
	PORT (
		pci : INOUT pci_bus;
		scsi : INOUT scsi_bus
	);
	ATTRIBUTE foreign OF pci_lsi_20810 : ENTITY IS "pci_lsi_20810";
END pci_lsi_20810;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_gen_dio24 IS
	PORT (
		pci : INOUT pci_bus;
		dio24 : INOUT dio24
	);
	ATTRIBUTE foreign OF pci_gen_dio24 : ENTITY IS "pci_gen_dio24";
END pci_gen_dio24;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY pci_gen_dio48 IS
	PORT (
		pci : INOUT pci_bus;
		dio48 : INOUT dio48
	);
	ATTRIBUTE foreign OF pci_gen_dio48 : ENTITY IS "pci_gen_dio48";
END pci_gen_dio48;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY scsi_gen_cdrom IS
	GENERIC (
		scsi_id : integer := 0
	);
	PORT (
		power : IN power_device;
		scsi : INOUT scsi_bus;
		change : IN cstring
	);
	ATTRIBUTE foreign OF scsi_gen_cdrom : ENTITY IS "scsi_gen_cdrom";
END scsi_gen_cdrom;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY scsi_gen_disk IS
	GENERIC (
		scsi_id : integer := 0;
		size : integer := 2047
	);
	PORT (
		power : IN power_device;
		scsi : INOUT scsi_bus
	);
	ATTRIBUTE foreign OF scsi_gen_disk : ENTITY IS "scsi_gen_disk";
END scsi_gen_disk;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY ide_gen_cdrom IS
	GENERIC (
		model : string := "FAUmachine CDROM";
		unit : integer := 0
	);
	PORT (
		power : IN power_device;
		ide : INOUT ide_bus;
		change : IN cstring;
		fault : boolean
	);
	ATTRIBUTE foreign OF ide_gen_cdrom : ENTITY IS "ide_gen_cdrom";
END ide_gen_cdrom;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY ide_gen_disk IS
	GENERIC (
		model : string := "FAUmachine Disk";
		unit : integer := 0;
		size : integer := 2047
	);
	PORT (
		power : IN power_device;
		ide : INOUT ide_bus;
		disk_fault : boolean;
		block_fault : boolean
	);
	ATTRIBUTE foreign OF ide_gen_disk : ENTITY IS "ide_gen_disk";
END ide_gen_disk;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY floppy_gen_floppydrive IS
	GENERIC (
		unit : integer := 0;
		model : integer := 4
	);
	PORT (
		power : IN power_device;
		shugart : INOUT shugart_bus;
		opt_busy_led : OUT boolean;
		change : IN cstring
	);
	ATTRIBUTE foreign OF floppy_gen_floppydrive : ENTITY IS "floppy_gen_floppydrive";
END floppy_gen_floppydrive;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY keyboard IS
	PORT (
		ps2 : INOUT ps2;
		key0 : IN boolean;
		key1 : IN boolean;
		key2 : IN boolean;
		key3 : IN boolean;
		key4 : IN boolean;
		key5 : IN boolean;
		key6 : IN boolean;
		key7 : IN boolean;
		key8 : IN boolean;
		key9 : IN boolean;
		key10 : IN boolean;
		key11 : IN boolean;
		key12 : IN boolean;
		key13 : IN boolean;
		key14 : IN boolean;
		key15 : IN boolean;
		key16 : IN boolean;
		key17 : IN boolean;
		key18 : IN boolean;
		key19 : IN boolean;
		key20 : IN boolean;
		key21 : IN boolean;
		key22 : IN boolean;
		key23 : IN boolean;
		key24 : IN boolean;
		key25 : IN boolean;
		key26 : IN boolean;
		key27 : IN boolean;
		key28 : IN boolean;
		key29 : IN boolean;
		key30 : IN boolean;
		key31 : IN boolean;
		key32 : IN boolean;
		key33 : IN boolean;
		key34 : IN boolean;
		key35 : IN boolean;
		key36 : IN boolean;
		key37 : IN boolean;
		key38 : IN boolean;
		key39 : IN boolean;
		key40 : IN boolean;
		key41 : IN boolean;
		key42 : IN boolean;
		key43 : IN boolean;
		key44 : IN boolean;
		key45 : IN boolean;
		key46 : IN boolean;
		key47 : IN boolean;
		key48 : IN boolean;
		key49 : IN boolean;
		key50 : IN boolean;
		key51 : IN boolean;
		key52 : IN boolean;
		key53 : IN boolean;
		key54 : IN boolean;
		key55 : IN boolean;
		key56 : IN boolean;
		key57 : IN boolean;
		key58 : IN boolean;
		key59 : IN boolean;
		key60 : IN boolean;
		key61 : IN boolean;
		key62 : IN boolean;
		key63 : IN boolean;
		key64 : IN boolean;
		key65 : IN boolean;
		key66 : IN boolean;
		key67 : IN boolean;
		key68 : IN boolean;
		key69 : IN boolean;
		key70 : IN boolean;
		key71 : IN boolean;
		key72 : IN boolean;
		key73 : IN boolean;
		key74 : IN boolean;
		key75 : IN boolean;
		key76 : IN boolean;
		key77 : IN boolean;
		key78 : IN boolean;
		key79 : IN boolean;
		key80 : IN boolean;
		key81 : IN boolean;
		key82 : IN boolean;
		key83 : IN boolean;
		key84 : IN boolean;
		key85 : IN boolean;
		key86 : IN boolean;
		key87 : IN boolean;
		key88 : IN boolean;
		key89 : IN boolean;
		key90 : IN boolean;
		key91 : IN boolean;
		key92 : IN boolean;
		key93 : IN boolean;
		key94 : IN boolean;
		key95 : IN boolean;
		key96 : IN boolean;
		key97 : IN boolean;
		key98 : IN boolean;
		key99 : IN boolean;
		key100 : IN boolean;
		key101 : IN boolean;
		key102 : IN boolean;
		key103 : IN boolean;
		key104 : IN boolean;
		key105 : IN boolean;
		key106 : IN boolean;
		key107 : IN boolean;
		key108 : IN boolean;
		key109 : IN boolean;
		key110 : IN boolean;
		key111 : IN boolean;
		key112 : IN boolean;
		key113 : IN boolean;
		key114 : IN boolean;
		key115 : IN boolean;
		key116 : IN boolean;
		key117 : IN boolean;
		key118 : IN boolean;
		key119 : IN boolean;
		key120 : IN boolean;
		key121 : IN boolean;
		key122 : IN boolean;
		key123 : IN boolean;
		key124 : IN boolean;
		key125 : IN boolean;
		key126 : IN boolean;
		key127 : IN boolean;
		opt_num_led : OUT boolean;
		opt_caps_led : OUT boolean;
		opt_scroll_led : OUT boolean
	);
	ATTRIBUTE foreign OF keyboard : ENTITY IS "keyboard";
END keyboard;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY ps2_gen_mouse_4 IS
	PORT (
		ps2 : INOUT ps2;
		deltax : IN integer;
		deltay : IN integer;
		deltaz : IN integer;
		button1 : IN boolean;
		button2 : IN boolean;
		button3 : IN boolean;
		button4 : IN boolean;
		button5 : IN boolean
	);
	ATTRIBUTE foreign OF ps2_gen_mouse_4 : ENTITY IS "ps2_gen_mouse_4";
END ps2_gen_mouse_4;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY vt102_monitor IS
	PORT (
		power_230v : IN boolean;
		in_video : IN video;
		opt_video : OUT opt_rgb;
		screen_shot : IN integer
	);
	ATTRIBUTE foreign OF vt102_monitor : ENTITY IS "vt102_monitor";
END vt102_monitor;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY monitor IS
	PORT (
		power_230v : IN boolean;
		vga : IN vga;
		opt_video : OUT opt_rgb;
		screen_shot : IN integer
	);
	ATTRIBUTE foreign OF monitor : ENTITY IS "monitor";
END monitor;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY patternm IS
	PORT (
		video : IN opt_rgb;
		slot0 : INOUT match;
		slot1 : INOUT match;
		slot2 : INOUT match;
		slot3 : INOUT match;
		slot4 : INOUT match;
		slot5 : INOUT match;
		slot6 : INOUT match;
		slot7 : INOUT match;
		slot8 : INOUT match;
		slot9 : INOUT match;
		slot10 : INOUT match;
		slot11 : INOUT match;
		slot12 : INOUT match;
		slot13 : INOUT match;
		slot14 : INOUT match;
		slot15 : INOUT match;
		text0 : IN cstring;
		text0_state : OUT boolean;
		text1 : IN cstring;
		text1_state : OUT boolean;
		text2 : IN cstring;
		text2_state : OUT boolean;
		text3 : IN cstring;
		text3_state : OUT boolean;
		asc_text0 : IN cstring;
		asc_text0_state : OUT boolean;
		asc_text1 : IN cstring;
		asc_text1_state : OUT boolean;
		asc_text2 : IN cstring;
		asc_text2_state : OUT boolean;
		asc_text3 : IN cstring;
		asc_text3_state : OUT boolean;
		pattern_rectangle0 : IN cstring;
		match_rectangle0_x : OUT integer;
		match_rectangle0_y : OUT integer;
		match_rectangle0_w : OUT integer;
		match_rectangle0_h : OUT integer;
		pattern_rectangle1 : IN cstring;
		match_rectangle1_x : OUT integer;
		match_rectangle1_y : OUT integer;
		match_rectangle1_w : OUT integer;
		match_rectangle1_h : OUT integer;
		pattern_rectangle2 : IN cstring;
		match_rectangle2_x : OUT integer;
		match_rectangle2_y : OUT integer;
		match_rectangle2_w : OUT integer;
		match_rectangle2_h : OUT integer;
		pattern_rectangle3 : IN cstring;
		match_rectangle3_x : OUT integer;
		match_rectangle3_y : OUT integer;
		match_rectangle3_w : OUT integer;
		match_rectangle3_h : OUT integer
	);
	ATTRIBUTE foreign OF patternm : ENTITY IS "patternm";
END patternm;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY mouse_matcher IS
	PORT (
		pointerdir : IN cstring;
		match_state : OUT boolean;
		event : OUT boolean;
		x : OUT integer;
		y : OUT integer;
		slot0 : INOUT match;
		slot1 : INOUT match;
		slot2 : INOUT match;
		slot3 : INOUT match;
		slot4 : INOUT match;
		slot5 : INOUT match;
		slot6 : INOUT match;
		slot7 : INOUT match;
		slot8 : INOUT match;
		slot9 : INOUT match;
		slot10 : INOUT match;
		slot11 : INOUT match
	);
	ATTRIBUTE foreign OF mouse_matcher : ENTITY IS "mouse_matcher";
END mouse_matcher;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY loudspeaker IS
	PORT (
		sound_in : IN sound;
		audio_sound : OUT sound
	);
	ATTRIBUTE foreign OF loudspeaker : ENTITY IS "loudspeaker";
END loudspeaker;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY usb2serial IS
	PORT (
		serial : INOUT serial;
		usb : INOUT usb_bus
	);
	ATTRIBUTE foreign OF usb2serial : ENTITY IS "usb2serial";
END usb2serial;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY usbstorage IS
	PORT (
		usb : INOUT usb_bus
	);
	ATTRIBUTE foreign OF usbstorage : ENTITY IS "usbstorage";
END usbstorage;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY vt102_keyboard IS
	PORT (
		keyboard : OUT character;
		key0 : IN boolean;
		key1 : IN boolean;
		key2 : IN boolean;
		key3 : IN boolean;
		key4 : IN boolean;
		key5 : IN boolean;
		key6 : IN boolean;
		key7 : IN boolean;
		key8 : IN boolean;
		key9 : IN boolean;
		key10 : IN boolean;
		key11 : IN boolean;
		key12 : IN boolean;
		key13 : IN boolean;
		key14 : IN boolean;
		key15 : IN boolean;
		key16 : IN boolean;
		key17 : IN boolean;
		key18 : IN boolean;
		key19 : IN boolean;
		key20 : IN boolean;
		key21 : IN boolean;
		key22 : IN boolean;
		key23 : IN boolean;
		key24 : IN boolean;
		key25 : IN boolean;
		key26 : IN boolean;
		key27 : IN boolean;
		key28 : IN boolean;
		key29 : IN boolean;
		key30 : IN boolean;
		key31 : IN boolean;
		key32 : IN boolean;
		key33 : IN boolean;
		key34 : IN boolean;
		key35 : IN boolean;
		key36 : IN boolean;
		key37 : IN boolean;
		key38 : IN boolean;
		key39 : IN boolean;
		key40 : IN boolean;
		key41 : IN boolean;
		key42 : IN boolean;
		key43 : IN boolean;
		key44 : IN boolean;
		key45 : IN boolean;
		key46 : IN boolean;
		key47 : IN boolean;
		key48 : IN boolean;
		key49 : IN boolean;
		key50 : IN boolean;
		key51 : IN boolean;
		key52 : IN boolean;
		key53 : IN boolean;
		key54 : IN boolean;
		key55 : IN boolean;
		key56 : IN boolean;
		key57 : IN boolean;
		key58 : IN boolean;
		key59 : IN boolean;
		key60 : IN boolean;
		key61 : IN boolean;
		key62 : IN boolean;
		key63 : IN boolean;
		key64 : IN boolean;
		key65 : IN boolean;
		key66 : IN boolean;
		key67 : IN boolean;
		key68 : IN boolean;
		key69 : IN boolean;
		key70 : IN boolean;
		key71 : IN boolean;
		key72 : IN boolean;
		key73 : IN boolean;
		key74 : IN boolean;
		key75 : IN boolean;
		key76 : IN boolean;
		key77 : IN boolean;
		key78 : IN boolean;
		key79 : IN boolean;
		key80 : IN boolean;
		key81 : IN boolean;
		key82 : IN boolean;
		key83 : IN boolean;
		key84 : IN boolean;
		key85 : IN boolean;
		key86 : IN boolean;
		key87 : IN boolean;
		key88 : IN boolean;
		key89 : IN boolean;
		key90 : IN boolean;
		key91 : IN boolean;
		key92 : IN boolean;
		key93 : IN boolean;
		key94 : IN boolean;
		key95 : IN boolean;
		key96 : IN boolean;
		key97 : IN boolean;
		key98 : IN boolean;
		key99 : IN boolean;
		key100 : IN boolean;
		key101 : IN boolean;
		key102 : IN boolean;
		key103 : IN boolean;
		key104 : IN boolean;
		key105 : IN boolean;
		key106 : IN boolean;
		key107 : IN boolean;
		key108 : IN boolean;
		key109 : IN boolean;
		key110 : IN boolean;
		key111 : IN boolean;
		key112 : IN boolean;
		key113 : IN boolean;
		key114 : IN boolean;
		key115 : IN boolean;
		key116 : IN boolean;
		key117 : IN boolean;
		key118 : IN boolean;
		key119 : IN boolean;
		key120 : IN boolean;
		key121 : IN boolean;
		key122 : IN boolean;
		key123 : IN boolean;
		key124 : IN boolean;
		key125 : IN boolean;
		key126 : IN boolean;
		key127 : IN boolean
	);
	ATTRIBUTE foreign OF vt102_keyboard : ENTITY IS "vt102_keyboard";
END vt102_keyboard;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY vt102_core IS
	PORT (
		mech_power_switch : IN boolean;
		serial : INOUT serial;
		keyboard : IN character;
		video : OUT video
	);
	ATTRIBUTE foreign OF vt102_core : ENTITY IS "vt102_core";
END vt102_core;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY cb_intel_eepro100 IS
	GENERIC (
		mac : string := "00:00:00:00:00:00"
	);
	PORT (
		card : INOUT cardbus;
		eth : INOUT eth;
		opt_power_led : OUT boolean;
		opt_busy_led : OUT boolean;
		recv_loss : integer;
		send_loss : integer
	);
	ATTRIBUTE foreign OF cb_intel_eepro100 : ENTITY IS "cb_intel_eepro100";
END cb_intel_eepro100;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY dhcp_server IS
	GENERIC (
		mac : string := "00:00:00:00:00:00";
		ip : string := "10.0.0.1";
		first_ip : string := "10.0.0.2";
		netmask : string := "255.255.255.0";
		broadcast : string := "10.0.0.255";
		default_router : string := "10.0.0.1";
		dns_server : string := "131.188.3.73"
	);
	PORT (
		eth : INOUT eth
	);
	ATTRIBUTE foreign OF dhcp_server : ENTITY IS "dhcp_server";
END dhcp_server;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY serial_modem IS
	PORT (
		switch : IN boolean;
		serial : INOUT serial;
		phone : INOUT telephone;
		opt_online_led : OUT boolean;
		opt_rxd_led : OUT boolean;
		opt_txd_led : OUT boolean
	);
	ATTRIBUTE foreign OF serial_modem : ENTITY IS "serial_modem";
END serial_modem;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY printer IS
	PORT (
		par : INOUT parallel
	);
	ATTRIBUTE foreign OF printer : ENTITY IS "printer";
END printer;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY telephone_switch IS
	GENERIC (
		num1 : integer := 1;
		num2 : integer := 2;
		num3 : integer := 3
	);
	PORT (
		switch : IN boolean;
		phone0 : INOUT telephone;
		phone1 : INOUT telephone;
		phone2 : INOUT telephone;
		carrier0 : OUT boolean;
		carrier1 : OUT boolean;
		carrier2 : OUT boolean;
		connected0 : OUT integer;
		connected1 : OUT integer;
		connected2 : OUT integer
	);
	ATTRIBUTE foreign OF telephone_switch : ENTITY IS "telephone_switch";
END telephone_switch;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY telephone_isp IS
	PORT (
		phone : INOUT telephone;
		switch : IN boolean
	);
	ATTRIBUTE foreign OF telephone_isp : ENTITY IS "telephone_isp";
END telephone_isp;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY elevator IS
	PORT (
		mech_power_switch : IN boolean;
		dio48 : INOUT dio48;
		opt_led_a : OUT boolean;
		opt_led_b : OUT boolean;
		opt_led_c : OUT boolean;
		opt_led_d : OUT boolean;
		opt_led_e : OUT boolean;
		opt_led_f : OUT boolean;
		opt_led_g : OUT boolean;
		opt_led_arrow_down : OUT boolean;
		opt_led_arrow_up : OUT boolean;
		opt_led_panel_0 : OUT boolean;
		opt_led_panel_1 : OUT boolean;
		opt_led_panel_2 : OUT boolean;
		opt_led_0_up : OUT boolean;
		opt_led_1_down : OUT boolean;
		opt_led_1_up : OUT boolean;
		opt_led_2_down : OUT boolean;
		mech_button_panel_0 : IN boolean;
		mech_button_panel_1 : IN boolean;
		mech_button_panel_2 : IN boolean;
		mech_button_0_up : IN boolean;
		mech_button_1_down : IN boolean;
		mech_button_1_up : IN boolean;
		mech_button_2_down : IN boolean;
		mech_door_0 : OUT integer;
		mech_door_1 : OUT integer;
		mech_door_2 : OUT integer;
		mech_cabin : OUT integer
	);
	ATTRIBUTE foreign OF elevator : ENTITY IS "elevator";
END elevator;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY elevator_rc IS
	PORT (
		dio48 : INOUT dio48
	);
	ATTRIBUTE foreign OF elevator_rc : ENTITY IS "elevator_rc";
END elevator_rc;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY network_bridge IS
	PORT (
		eth : INOUT eth
	);
	ATTRIBUTE foreign OF network_bridge : ENTITY IS "network_bridge";
END network_bridge;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY network_router IS
	GENERIC (
		mac : string := "00:00:00:00:00:00";
		ip : string := "10.0.0.1";
		first_ip : string := "10.0.0.2";
		netmask : string := "255.255.255.0";
		broadcast : string := "10.0.0.255";
		default_router : string := "10.0.0.1";
		dns_server : string := "131.188.3.73"
	);
	PORT (
		console : INOUT serial;
		eth : INOUT eth
	);
	ATTRIBUTE foreign OF network_router : ENTITY IS "network_router";
END network_router;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY dio24_loopback IS
	PORT (
		dio24 : INOUT dio24
	);
	ATTRIBUTE foreign OF dio24_loopback : ENTITY IS "dio24_loopback";
END dio24_loopback;

USE types.all;
LIBRARY ieee;
USE ieee.std_logic_1164.all;
ENTITY dio48_loopback IS
	PORT (
		dio48 : INOUT dio48
	);
	ATTRIBUTE foreign OF dio48_loopback : ENTITY IS "dio48_loopback";
END dio48_loopback;

